## dssp 4.0.4

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
#    this list of conditions and the following disclaimer in the documentation
#    and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.15)

# set the project name
project(mkdssp VERSION 4.0.4 LANGUAGES CXX)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CMakePackageConfigHelpers)
include(Dart)
include(FindFilesystem)
include(GenerateExportHeader)

set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Filesystem REQUIRED)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers")
elseif(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

if(NOT "$ENV{CCP4}" STREQUAL "")
	set(CCP4 $ENV{CCP4})
	list(PREPEND CMAKE_MODULE_PATH "${CCP4}/Lib")
	list(APPEND CMAKE_PREFIX_PATH ${CCP4})
	if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
		set(CMAKE_INSTALL_PREFIX ${CCP4})
	endif()
endif()

if(MSVC)
    # make msvc standards compliant...
    add_compile_options(/permissive-)

	macro(get_WIN32_WINNT version)
		if (WIN32 AND CMAKE_SYSTEM_VERSION)
			set(ver ${CMAKE_SYSTEM_VERSION})
			string(REPLACE "." "" ver ${ver})
			string(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})

			set(${version} "0x${ver}")
		endif()
	endmacro()

	get_WIN32_WINNT(ver)
	add_definitions(-D_WIN32_WINNT=${ver})

	# On Windows, do not install in the system location
	if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT AND NOT BUILD_FOR_CCP4)
		message(STATUS "The library and auxiliary files will be installed in $ENV{LOCALAPPDATA}/${PROJECT_NAME}")
		set(CMAKE_INSTALL_PREFIX "$ENV{LOCALAPPDATA}/${PROJECT_NAME}" CACHE PATH "..." FORCE)
	endif()
endif()

if(UNIX AND NOT APPLE)
	# On Linux, install in the $HOME/.local folder by default
	if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
		message(WARNING "The library and auxiliary files will be installed in $ENV{HOME}/.local")
		set(CMAKE_INSTALL_PREFIX "$ENV{HOME}/.local" CACHE PATH "..." FORCE)

		# libcifpp will be there as well, likely
		list(PREPEND CMAKE_PREFIX_PATH "$ENV{HOME}/.local")
	endif()
endif()

# Create a revision file, containing the current git version info
include(VersionString)
write_version_header()

# Optionally use mrc to create resources
find_package(Mrc)

if(MRC_FOUND)
	option(USE_RSRC "Use mrc to create resources" ON)
else()
	message(WARNING "Not using resources since mrc was not found")
endif()

if(USE_RSRC)
	set(USE_RSRC 1)

	message("Using resources compiled with ${MRC}")
	add_compile_definitions(USE_RSRC)
endif()

set(CMAKE_THREAD_PREFER_PTHREAD)
set(THREADS_PREFER_PTHREAD_FLAG)
find_package(Threads)

# Note: use -DBoost_USE_STATIC_LIBS=ON to use boost static libraries

find_package(cifpp 2.0.0 REQUIRED)
find_package(Boost COMPONENTS date_time program_options)

add_executable(mkdssp
	${PROJECT_SOURCE_DIR}/src/dssp.cpp
	${PROJECT_SOURCE_DIR}/src/dssp.hpp
	${PROJECT_SOURCE_DIR}/src/mkdssp.cpp)

target_include_directories(mkdssp PRIVATE cifpp::cifpp ${CMAKE_SOURCE_DIR}/include ${CMAKE_BINARY_DIR})
target_link_libraries(mkdssp PRIVATE cifpp::cifpp Boost::date_time Boost::program_options)
	
if(USE_RSRC)
	mrc_target_resources(mkdssp ${CIFPP_SHARE_DIR}/mmcif_pdbx_v50.dic)
endif()

install(TARGETS ${PROJECT_NAME}
    RUNTIME DESTINATION ${BIN_INSTALL_DIR}
)

# manual

if(UNIX)
	install(FILES doc/mkdssp.1
		DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1)
endif()

if(EXISTS "${CCP4}/html")
	install(FILES doc/mkdssp.html
		DESTINATION ${CCP4}/html)
endif()

# test

add_executable(unit-test ${PROJECT_SOURCE_DIR}/test/unit-test.cpp ${PROJECT_SOURCE_DIR}/src/dssp.cpp)

if(USE_RSRC)
	mrc_target_resources(unit-test ${CIFPP_SHARE_DIR}/mmcif_pdbx_v50.dic)
endif()

target_include_directories(unit-test PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}/src
	${CMAKE_CURRENT_SOURCE_DIR}/include
)

target_link_libraries(unit-test cifpp::cifpp Boost::date_time)

if(MSVC)
	# Specify unwind semantics so that MSVC knowns how to handle exceptions
	target_compile_options(unit-test PRIVATE /EHsc)
endif()

enable_testing()

add_test(NAME unit-test
	COMMAND $<TARGET_FILE:unit-test>
	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/test)

option(DSSP_BUILD_INSTALLER "Build an installer" OFF)
if(DSSP_BUILD_INSTALLER)
	include(InstallRequiredSystemLibraries)
	set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
	
	# NSIS options
	set(CPACK_NSIS_MODIFY_PATH ON)

	# configuration done, include CPack

	include(CPack)
endif()

## dssp 2.0.4

=== debian/changelog ===
dssp (2.0.4-2) unstable; urgency=low

  [ Laszlo Kajan ]
  * Stick to debhelper compatibility level 7 to enable flawless
    build on Ubuntu Lucid (documented in debian/README.source)

  [ Maarten L. Hekkelman ]
  * Fix for compiling with gcc 4.7, std::min (Closes: #673434)
  * Added the use of dpkg-buildflags to include hardening flags since
    debhelper is still maintained at version 7.

 -- Maarten L. Hekkelman <m.hekkelman@cmbi.ru.nl>  Mon, 21 May 2012 10:00:00 +0200

dssp (2.0.4-1) unstable; urgency=low

  * Initial release. (Closes: #669259)
  * Added description to dssp; added upstream (reference); parallel building
    now enabled; fixed spelling error in man page; added debug package;
    fixed debian/watch; added get-orig-source target to rules.
  * Changed libboost build dependency to version >= 1.42.0.1 to allow
    building on stable.

 -- Laszlo Kajan <lkajan@rostlab.org>  Wed, 18 Apr 2012 11:09:02 +0200

=== debian/control ===
Source: dssp
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <m.hekkelman@cmbi.ru.nl>,
 Laszlo Kajan <lkajan@rostlab.org>,
 Andreas Tille <tille@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
               libboost-filesystem-dev (>= 1.42.0.1), 
               libboost-iostreams-dev (>= 1.42.0.1), 
               libboost-program-options-dev (>= 1.42.0.1), 
               libboost-system-dev (>= 1.42.0.1), 
               libboost-thread-dev (>= 1.42.0.1)
Standards-Version: 3.9.3
Section: science
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/dssp/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/dssp/trunk/
DM-Upload-Allowed: yes
Homepage: http://www.cmbi.ru.nl/dssp.html

Package: dssp
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: protein secondary structure assignment based on 3D structure
 DSSP is an application you use to assign the secondary structure of a protein
 based on its solved three dimensional (3D) structure.
 .
 This version (2) of DSSP is a rewrite that produces the same output as the
 original DSSP, but deals better with exceptions in PDB files and is much
 faster.

Package: dssp-dbg
Architecture: any
Section: debug
Priority: extra
Depends: dssp (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for dssp
 DSSP is an application to assign the secondary structure of a protein
 based on its three dimensional (3D) structure.
 .
 This version (2) of DSSP is a rewrite that produces the same output as the
 original DSSP, but deals better with exceptions in PDB files and is much
 faster.
 .
 This package provides the detached debug symbols for dssp.

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1
PPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

%:
	dh $@ --parallel

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=dssp-dbg

.PHONY: get-orig-source
get-orig-source:
	mkdir -p ../tarballs
	uscan --verbose --force-download --destdir=../tarballs

## dssp 2.1.0

=== debian/changelog ===
dssp (2.1.0-1) unstable; urgency=low

  * New upstream release.
  * Boost got fixed, bug was 'FTBFS: xtime.hpp:23:5: error: expected
    identifier before numeric constant' (no changes to dssp were
    required to solve bug) (Closes: #708446)

 -- Laszlo Kajan <lkajan@rostlab.org>  Wed, 08 May 2013 18:20:06 +0200

=== debian/control ===
--- 
+++ 
@@ -5,16 +5,15 @@
  Laszlo Kajan <lkajan@rostlab.org>,
  Andreas Tille <tille@debian.org>
 Build-Depends: debhelper (>= 7.0.50~),
-               libboost-filesystem-dev (>= 1.42.0.1), 
-               libboost-iostreams-dev (>= 1.42.0.1), 
-               libboost-program-options-dev (>= 1.42.0.1), 
-               libboost-system-dev (>= 1.42.0.1), 
-               libboost-thread-dev (>= 1.42.0.1)
-Standards-Version: 3.9.3
+               libboost-filesystem-dev (>= 1.46.0), 
+               libboost-iostreams-dev (>= 1.42.0), 
+               libboost-program-options-dev (>= 1.42.0), 
+               libboost-system-dev (>= 1.42.0), 
+               libboost-thread-dev (>= 1.42.0)
+Standards-Version: 3.9.4
 Section: science
 Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/dssp/trunk/
 Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/dssp/trunk/
-DM-Upload-Allowed: yes
 Homepage: http://www.cmbi.ru.nl/dssp.html
 
 Package: dssp

## dssp 2.2.1

=== debian/changelog ===
dssp (2.2.1-2ubuntu1) wily; urgency=medium

  * Build with -O2 on ppc64el (ICE).

 -- Matthias Klose <doko@ubuntu.com>  Fri, 14 Aug 2015 14:12:24 +0000

dssp (2.2.1-2build1) wily; urgency=medium

  * No change rebuild for boost1.58.

 -- Andy Whitcroft <apw@ubuntu.com>  Wed, 12 Aug 2015 00:11:35 +0100

dssp (2.2.1-2) unstable; urgency=medium

  * Add symlink dssp as executable since BioPython is relying on the
    old name
  * debhelper 9
  * cme fix dpkg-control

 -- Andreas Tille <tille@debian.org>  Mon, 10 Mar 2014 10:48:09 +0100

dssp (2.2.1-1) unstable; urgency=low

  * Bug fix in mmCIF import code.
  * New upstream release.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 11 Sep 2013 10:00:00 +0200

=== debian/control ===
Source: dssp
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>,
           Laszlo Kajan <lkajan@rostlab.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               libboost-filesystem-dev (>= 1.46.0),
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/dssp/trunk/
Vcs-Svn: svn://anonscm.debian.org/debian-med/trunk/packages/dssp/trunk/
Homepage: http://www.cmbi.ru.nl/dssp.html

Package: dssp
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: protein secondary structure assignment based on 3D structure
 DSSP is an application you use to assign the secondary structure of a protein
 based on its solved three dimensional (3D) structure.
 .
 This version (2) of DSSP is a rewrite that produces the same output as the
 original DSSP, but deals better with exceptions in PDB files and is much
 faster.

Package: dssp-dbg
Architecture: any
Section: debug
Priority: extra
Depends: dssp (= ${binary:Version}),
         ${misc:Depends}
Description: debugging symbols for dssp
 DSSP is an application to assign the secondary structure of a protein
 based on its three dimensional (3D) structure.
 .
 This version (2) of DSSP is a rewrite that produces the same output as the
 original DSSP, but deals better with exceptions in PDB files and is much
 faster.
 .
 This package provides the detached debug symbols for dssp.

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE := 1
export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

ifeq ($(DEB_HOST_ARCH),ppc64el)
  CFLAGS := $(subst -O3,-O2,$(CFLAGS))
  CXXFLAGS := $(subst -O3,-O2,$(CXXFLAGS))
  export CFLAGS CXXFLAGS
endif

export DEST_DIR:=/usr
export LDOPTS:=$(LDFLAGS)

%:
	dh $@ --parallel

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbg-package=dssp-dbg

.PHONY: get-orig-source
get-orig-source:
	mkdir -p ../tarballs
	uscan --verbose --force-download --destdir=../tarballs

=== debian/watch ===
version=3
opts="pasv" \
ftp://ftp.cmbi.ru.nl/pub/software/dssp/dssp-([0-9.]+)\.t[bgx]z  debian uupdate

## dssp 3.0.0

=== debian/changelog ===
dssp (3.0.0-2) unstable; urgency=medium

  * Team upload

  [ Steffen Moeller ]
  * debian/upstream/metadata
    - Added references to registries
    - Upstream name is "DSSP" (all caps), also changed in d/copyright
    - yamllint clean

  [ Gert Wollny ]
  * d/p/boost1.65: Add patch for boost 1.65, Closes: #880465
  * d/control: Update standards to 4.1.1 (no changes)

 -- Gert Wollny <gewo@debian.org>  Wed, 06 Dec 2017 19:46:08 +0100

dssp (3.0.0-1) unstable; urgency=medium

  * New upstream version
  * Moved packaging to Git
  * Simplify d/watch
  * Drop debug package
  * Cleanup make.config
  * debhelper 10
  * Standards-Version: 4.1.0 (no changes needed)

 -- Andreas Tille <tille@debian.org>  Wed, 27 Sep 2017 10:20:39 +0200

dssp (2.2.1-3) unstable; urgency=medium

  * Team upload.
  [ Tatiana Malygina ]
  * cme fix dpkg-control
  * add example files
  * add simple testsuite and README.test
  * turn on hardening
  * move examples from upstream patch to d/examples
  * add information on .pdb example files to d/copyright

  [ Andreas Tille ]
  * Fix sequence of files in d/copyright
  * Secure Vcs-Browser
  * Propagate hardening options

 -- Tatiana Malygina <merlettaia@gmail.com>  Tue, 07 Jun 2016 14:58:19 +0000

=== debian/control ===
Source: dssp
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>,
           Laszlo Kajan <lkajan@rostlab.org>,
           Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/dssp.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/dssp.git
Homepage: http://www.cmbi.ru.nl/dssp.html

Package: dssp
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: protein secondary structure assignment based on 3D structure
 DSSP is an application you use to assign the secondary structure of a protein
 based on its solved three dimensional (3D) structure.
 .
 This version (2) of DSSP is a rewrite that produces the same output as the
 original DSSP, but deals better with exceptions in PDB files and is much
 faster.

=== debian/rules ===
#!/usr/bin/make -f
#DH_VERBOSE := 1
export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export DEST_DIR:=/usr
export LDOPTS:=$(LDFLAGS)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

=== debian/watch ===
version=4
opts="pasv" \
ftp://ftp.cmbi.ru.nl/pub/software/dssp/dssp-([0-9.]+)\.t[bgx]z

## dssp 4.0.0

=== debian/changelog ===
dssp (4.0.0-2) unstable; urgency=medium

  * Make build reproducible, Closes: #977618

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 18 Dec 2020 07:42:13 +0100

dssp (4.0.0-1) unstable; urgency=medium

  * New upstream release

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 24 Nov 2020 09:57:21 +0100

dssp (3.0.0-3) unstable; urgency=medium

  * debhelper 11
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.2.1
  * Secure URI in copyright format
  * Remove trailing whitespace in debian/copyright

 -- Andreas Tille <tille@debian.org>  Sun, 28 Oct 2018 11:18:40 +0100

=== debian/control ===
Source: dssp
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               autoconf-archive,
               pkg-config,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libcifpp-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/med-team/dssp
Vcs-Git: https://salsa.debian.org/med-team/dssp.git
Homepage: https://github.com/PDB-REDO/dssp

Package: dssp
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libcifpp1
Description: protein secondary structure assignment based on 3D structure
 DSSP is an application you use to assign the secondary structure of a protein
 based on its solved three dimensional (3D) structure.
 .
 This version (4.0) of DSSP is a rewrite that writes annotated mmCIF files
 by default but can still produce the older dssp format. New is also the
 support of PP helices.

=== debian/rules ===
#!/usr/bin/make -f

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

export DEST_DIR:=/usr
export LDOPTS:=$(LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --disable-resources --disable-revision

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, libcifpp-dev (>= 1.0.0-2)
Restrictions: allow-stderr

## dssp 4.0.4

=== debian/changelog ===
dssp (4.0.4-1) unstable; urgency=medium

  * New upstream release, Closes: #1005450 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 13 Feb 2022 10:23:33 +0100

dssp (4.0.3-1) unstable; urgency=medium

  * New upstream release

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 02 Nov 2021 07:53:02 +0100

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,14 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               autoconf-archive,
-               pkg-config,
+               cmake,
                libboost-iostreams-dev,
                libboost-program-options-dev,
                libboost-system-dev,
+               libboost-date-time-dev,
+               zlib1g-dev,
+               libbz2-dev,
+               mrc,
                libcifpp-dev
 Standards-Version: 4.5.0
 Rules-Requires-Root: no
@@ -20,7 +23,7 @@
 Architecture: any
 Depends: ${misc:Depends},
          ${shlibs:Depends},
-         libcifpp1
+         libcifpp2
 Description: protein secondary structure assignment based on 3D structure
  DSSP is an application you use to assign the secondary structure of a protein
  based on its solved three dimensional (3D) structure.

## dssp 4.2.1

=== debian/changelog ===
dssp (4.2.1-1) unstable; urgency=medium

  * New upstream.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 02 Jan 2023 09:53:03 +0100

dssp (4.2.0a-1) unstable; urgency=medium

  * Now with new source... 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sat, 31 Dec 2022 10:29:08 +0100

dssp (4.2.0-3) unstable; urgency=medium

  * Pushing.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 30 Dec 2022 20:26:13 +0100

dssp (4.2.0-2) unstable; urgency=medium

  * Without the -dev part.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 30 Dec 2022 09:52:34 +0100

dssp (4.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 24 Nov 2022 11:39:54 +0100

=== debian/control ===
Source: dssp
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
 cmake,
 mrc,
 libcifpp-dev (>= 5.0.5-2~),
 libboost-dev,
 libboost-regex-dev,
 zlib1g-dev,
 libmcfp-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/med-team/dssp
Vcs-Git: https://salsa.debian.org/med-team/dssp.git
Homepage: https://github.com/PDB-REDO/dssp

Package: dssp
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: protein secondary structure assignment based on 3D structure
 DSSP is an application you use to assign the secondary structure of a protein
 based on its solved three dimensional (3D) structure.
 .
 This version (4.2) of DSSP is a rewrite that writes annotated mmCIF files
 by default but can still produce the older dssp format. New is also the
 support of PP helices.

## dssp 4.2.2

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.15)

# set the project name
project(mkdssp VERSION 4.2.2 LANGUAGES CXX)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CMakePackageConfigHelpers)
include(Dart)
include(FindFilesystem)
include(GenerateExportHeader)

set(CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Filesystem REQUIRED)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers")
elseif(MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

# Optionally build a version to be installed inside CCP4
option(BUILD_FOR_CCP4 "Build a version to be installed in CCP4" OFF)

if(BUILD_FOR_CCP4)
	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
		message(FATAL_ERROR "A CCP4 built was requested but CCP4 was not sourced")
	else()
		list(APPEND CMAKE_MODULE_PATH "$ENV{CCP4}")
		list(APPEND CMAKE_PREFIX_PATH "$ENV{CCP4}")
		set(CMAKE_INSTALL_PREFIX "$ENV{CCP4}")

		if(WIN32)
			set(BUILD_SHARED_LIBS ON)
		endif()
	endif()
endif()

if(MSVC)
	# make msvc standards compliant...
	add_compile_options(/permissive-)

	macro(get_WIN32_WINNT version)
		if(WIN32 AND CMAKE_SYSTEM_VERSION)
			set(ver ${CMAKE_SYSTEM_VERSION})
			string(REPLACE "." "" ver ${ver})
			string(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})

			set(${version} "0x${ver}")
		endif()
	endmacro()

	get_WIN32_WINNT(ver)
	add_definitions(-D_WIN32_WINNT=${ver})
endif()

# Create a revision file, containing the current git version info
include(VersionString)
write_version_header("${PROJECT_SOURCE_DIR}/src")

# Optionally use mrc to create resources
find_package(Mrc QUIET)

if(MRC_FOUND)
	option(USE_RSRC "Use mrc to create resources" ON)
else()
	message(STATUS "Not using resources since mrc was not found")
endif()

set(CMAKE_THREAD_PREFER_PTHREAD)
set(THREADS_PREFER_PTHREAD_FLAG)
find_package(Threads)

if(NOT PDB_REDO_META)
	find_package(libmcfp REQUIRED)
	find_package(cifpp 5.0.6 REQUIRED)
endif()

# The DSSP code is in a separate library, optionally to be used by others
add_library(dssp ${PROJECT_SOURCE_DIR}/src/dssp.cpp ${PROJECT_SOURCE_DIR}/include/dssp.hpp)
add_library(dssp::dssp ALIAS dssp)

target_link_libraries(dssp PRIVATE cifpp::cifpp)

target_include_directories(dssp
	PUBLIC
	"$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
	"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

add_executable(mkdssp
	${PROJECT_SOURCE_DIR}/src/dssp-io.cpp
	${PROJECT_SOURCE_DIR}/src/dssp-io.hpp
	${PROJECT_SOURCE_DIR}/src/mkdssp.cpp)

target_include_directories(mkdssp PRIVATE ${PROJECT_BINARY_DIR})
target_link_libraries(mkdssp PRIVATE dssp cifpp::cifpp libmcfp::libmcfp dssp::dssp)

if(USE_RSRC)
	message("Using resources compiled with ${MRC}")
	mrc_target_resources(mkdssp ${CIFPP_SHARE_DIR}/mmcif_pdbx.dic ${CIFPP_SHARE_DIR}/mmcif_ddl.dic)
endif()

# Install rules
install(TARGETS dssp
	EXPORT dsspTargets
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

if(MSVC AND BUILD_SHARED_LIBS)
	install(
		FILES $<TARGET_PDB_FILE:${PROJECT_NAME}>
		DESTINATION ${CMAKE_INSTALL_LIBDIR}
		OPTIONAL)
endif()

install(EXPORT dsspTargets
	FILE "dsspTargets.cmake"
	NAMESPACE dssp::
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/dssp
)

install(
	FILES include/dssp.hpp
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
	COMPONENT Devel
)

set(CONFIG_TEMPLATE_FILE ${PROJECT_SOURCE_DIR}/cmake/dsspConfig.cmake.in)

configure_package_config_file(
	${CONFIG_TEMPLATE_FILE}
	${CMAKE_CURRENT_BINARY_DIR}/dssp/dsspConfig.cmake
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/dssp
)

install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/dssp/dsspConfig.cmake"
	"${CMAKE_CURRENT_BINARY_DIR}/dssp/dsspConfigVersion.cmake"
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/dssp
	COMPONENT Devel
)

set(dssp_MAJOR_VERSION ${CMAKE_PROJECT_VERSION_MAJOR})
set_target_properties(dssp PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${dssp_MAJOR_VERSION}
	INTERFACE_dssp_MAJOR_VERSION ${dssp_MAJOR_VERSION})

set_property(TARGET dssp APPEND PROPERTY
	COMPATIBLE_INTERFACE_STRING dssp_MAJOR_VERSION
)

write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/dssp/dsspConfigVersion.cmake"
	VERSION ${PROJECT_VERSION}
	COMPATIBILITY AnyNewerVersion
)

# pkgconfig support
set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${CMAKE_INSTALL_PREFIX})
set(libdir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR})
set(includedir ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/cmake/libdssp.pc.in
	${CMAKE_CURRENT_BINARY_DIR}/libdssp.pc.in @ONLY)
file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/libdssp.pc
	INPUT ${CMAKE_CURRENT_BINARY_DIR}/libdssp.pc.in)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libdssp.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

install(TARGETS ${PROJECT_NAME}
	RUNTIME DESTINATION ${BIN_INSTALL_DIR}
)

# manual
if(UNIX)
	install(FILES doc/mkdssp.1
		DESTINATION ${CMAKE_INSTALL_DATADIR}/man/man1)
endif()

if(EXISTS "${CCP4}/html")
	install(FILES doc/mkdssp.html
		DESTINATION ${CCP4}/html)
endif()

# test
if(ENABLE_TESTING)
	# We still depend on boost for the testing headers-only library
	find_package(Boost REQUIRED)

	add_executable(unit-test-dssp ${PROJECT_SOURCE_DIR}/test/unit-test-dssp.cpp ${PROJECT_SOURCE_DIR}/src/dssp-io.cpp)

	if(USE_RSRC)
		mrc_target_resources(unit-test-dssp ${CIFPP_SHARE_DIR}/mmcif_pdbx.dic ${CIFPP_SHARE_DIR}/mmcif_ddl.dic)
	endif()

	target_include_directories(unit-test-dssp PRIVATE
		${CMAKE_CURRENT_SOURCE_DIR}/src
		${CMAKE_CURRENT_SOURCE_DIR}/include
	)

	target_link_libraries(unit-test-dssp PRIVATE dssp cifpp::cifpp Boost::boost)

	if(MSVC)
		# Specify unwind semantics so that MSVC knowns how to handle exceptions
		target_compile_options(unit-test-dssp PRIVATE /EHsc)
	endif()

	enable_testing()

	add_test(NAME unit-test-dssp COMMAND $<TARGET_FILE:unit-test-dssp> -- ${PROJECT_SOURCE_DIR}/test)
endif()

include(InstallRequiredSystemLibraries)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")

# Tarball generation
set(CPACK_SOURCE_TGZ ON)
set(CPACK_SOURCE_TBZ2 OFF)
set(CPACK_SOURCE_TXZ OFF)
set(CPACK_SOURCE_TZ OFF)
set(CPACK_SOURCE_IGNORE_FILES "/data/components.cif;/build;/.vscode;/.git")
set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_FILE_NAME})

# NSIS options
set(CPACK_NSIS_MODIFY_PATH ON)

# configuration done, include CPack
include(CPack)

=== debian/changelog ===
dssp (4.2.2-2) unstable; urgency=medium

  * Fix dependency.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 02 Feb 2023 11:48:45 +0100

dssp (4.2.2-1) unstable; urgency=medium

  * New upstream. 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 02 Feb 2023 10:05:57 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
  cmake,
  mrc,
- libcifpp-dev (>= 5.0.5-2~),
+ libcifpp-dev (>= 5.0.7.1-1~),
  libboost-dev,
  libboost-regex-dev,
  zlib1g-dev,

## dssp 4.4.10

=== CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause

# Copyright (c) 2021 NKI/AVL, Netherlands Cancer Institute

# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:

# 1. Redistributions of source code must retain the above copyright notice, this
# list of conditions and the following disclaimer
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.

# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
# ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

cmake_minimum_required(VERSION 3.23)

# set the project name
project(mkdssp VERSION 4.4.10 LANGUAGES CXX)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(CTest)
include(VersionString)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wno-missing-field-initializers")
elseif(MSVC)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W4")
endif()

# Optionally build a version to be installed inside CCP4
option(BUILD_FOR_CCP4 "Build a version to be installed in CCP4" OFF)
option(BUILD_DOCUMENTATION "Generate the documentation files using pandoc" OFF)

if(BUILD_FOR_CCP4)
	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
		message(FATAL_ERROR "A CCP4 built was requested but CCP4 was not sourced")
	else()
		list(APPEND CMAKE_MODULE_PATH "$ENV{CCP4}")
		list(APPEND CMAKE_PREFIX_PATH "$ENV{CCP4}")
		set(CMAKE_INSTALL_PREFIX "$ENV{CCP4}")

		if(WIN32)
			set(BUILD_SHARED_LIBS ON)
		endif()
	endif()
endif()

if(MSVC)
	# make msvc standards compliant...
	add_compile_options(/permissive-)
	add_link_options(/NODEFAULTLIB:library)

	macro(get_WIN32_WINNT version)
		if(WIN32 AND CMAKE_SYSTEM_VERSION)
			set(ver ${CMAKE_SYSTEM_VERSION})
			string(REPLACE "." "" ver ${ver})
			string(REGEX REPLACE "([0-9])" "0\\1" ver ${ver})

			set(${version} "0x${ver}")
		endif()
	endmacro()

	get_WIN32_WINNT(ver)
	add_definitions(-D_WIN32_WINNT=${ver})

	if(BUILD_SHARED_LIBS)
		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
	else()
		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
	endif()
endif()

# Create a revision file, containing the current git version info
write_version_header("${CMAKE_CURRENT_SOURCE_DIR}/src")

# Optionally use mrc to create resources
find_package(Mrc QUIET)

if(MRC_FOUND)
	option(USE_RSRC "Use mrc to create resources" ON)
else()
	message(STATUS "Not using resources since mrc was not found")
endif()

set(CMAKE_THREAD_PREFER_PTHREAD)
set(THREADS_PREFER_PTHREAD_FLAG)
find_package(Threads)
find_package(libmcfp QUIET)

if(NOT (libmcfp_FOUND OR TARGET libmcfp))
	include(FetchContent)

	if(CMAKE_VERSION GREATER_EQUAL 3.28)
		set(EXLC "EXCLUDE_FROM_ALL")
	endif()

	FetchContent_Declare(
		libmcfp
		${EXLC}
		GIT_REPOSITORY https://github.com/mhekkel/libmcfp
		GIT_TAG v1.3.1)

	FetchContent_MakeAvailable(libmcfp)
endif()

if(NOT TARGET cifpp AND NOT cifpp_FOUND)
	include(FetchContent)

	find_package(cifpp 7.0.7 QUIET)

	if(NOT cifpp_FOUND)
		set(CIFPP_DOWNLOAD_CCD OFF)
		set(SAVED_BUILD_TESTING "${BUILD_TESTING}")
		set(BUILD_TESTING OFF)

		FetchContent_Declare(
			cifpp
			${EXLC}
			GIT_REPOSITORY https://github.com/pdb-redo/libcifpp.git
			GIT_TAG v7.0.7
		)

		FetchContent_MakeAvailable(cifpp)

		set(BUILD_TESTING ${SAVED_BUILD_TESTING})
	endif()
endif()

add_subdirectory(libdssp)

add_executable(mkdssp ${CMAKE_CURRENT_SOURCE_DIR}/src/mkdssp.cpp)

target_link_libraries(mkdssp PRIVATE libmcfp::libmcfp dssp::dssp)

if(USE_RSRC)
	mrc_target_resources(mkdssp
		${CIFPP_SHARE_DIR}/mmcif_pdbx.dic
		${CIFPP_SHARE_DIR}/mmcif_ddl.dic
		${CMAKE_CURRENT_SOURCE_DIR}/libdssp/mmcif_pdbx/dssp-extension.dic)
endif()

# Install rules
install(TARGETS ${PROJECT_NAME}
	RUNTIME DESTINATION bin
)

if(NOT USE_RSRC)
	# When building cifpp ourselves, we need to find where libcifpp
	# expects the data files to be located.
	if(TARGET cifpp)
		get_target_property(DSSP_DATA_DIR cifpp CIFPP_DATA_DIR)
		get_target_property(CIFPP_SOURCE_DIR cifpp SOURCE_DIR)

		install(
			FILES ${CIFPP_SOURCE_DIR}/rsrc/mmcif_pdbx.dic
			${CIFPP_SOURCE_DIR}/rsrc/mmcif_ddl.dic
			${CMAKE_CURRENT_SOURCE_DIR}/libdssp/mmcif_pdbx/dssp-extension.dic
			DESTINATION ${DSSP_DATA_DIR})
	else()

	endif()
endif()

if(BUILD_DOCUMENTATION)
	add_subdirectory(doc)
endif()

if(UNIX)
	install(FILES doc/mkdssp.1
		DESTINATION share/man/man1)
endif()

if(EXISTS "${CCP4}/html")
	install(FILES doc/mkdssp.html
		DESTINATION ${CCP4}/html)
endif()

# test
if(BUILD_TESTING)
	add_subdirectory(test)
endif()

include(InstallRequiredSystemLibraries)
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")

# Tarball generation
set(CPACK_SOURCE_TGZ ON)
set(CPACK_SOURCE_TBZ2 OFF)
set(CPACK_SOURCE_TXZ OFF)
set(CPACK_SOURCE_TZ OFF)
set(CPACK_SOURCE_IGNORE_FILES "/data/components.cif;/build;/.vscode;/.git")
set(CPACK_PACKAGE_FILE_NAME "${PROJECT_NAME}-${PROJECT_VERSION}")
set(CPACK_SOURCE_PACKAGE_FILE_NAME ${CPACK_PACKAGE_FILE_NAME})

# NSIS options
set(CPACK_NSIS_MODIFY_PATH ON)

# configuration done, include CPack
include(CPack)

=== doc/CMakeLists.txt ===
# manual 
find_program(PANDOC pandoc)

if(PANDOC)
	file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/pandoc-md.sh
		CONTENT "${PANDOC} ${CMAKE_CURRENT_SOURCE_DIR}/mkdssp.1 -t markdown | sed -e \"s/\\\\\\' \\\\\\' (space)/  ' ' (space)/\" > ${CMAKE_CURRENT_SOURCE_DIR}/mkdssp.md"
		FILE_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/mkdssp.md
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/mkdssp.1
		COMMAND "${CMAKE_CURRENT_BINARY_DIR}/pandoc-md.sh"
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
		VERBATIM)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/mkdssp.html
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/mkdssp.1
		COMMAND ${PANDOC} -o mkdssp.html mkdssp.1
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
		VERBATIM)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/mkdssp.pdf
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/mkdssp.1
		COMMAND ${PANDOC} -o mkdssp.pdf mkdssp.1 -t html
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
		VERBATIM)

	add_custom_target(doc_files DEPENDS
		${CMAKE_CURRENT_SOURCE_DIR}/mkdssp.html
		${CMAKE_CURRENT_SOURCE_DIR}/mkdssp.pdf
		${CMAKE_CURRENT_SOURCE_DIR}/mkdssp.md)

	add_dependencies(mkdssp doc_files)
else()
	message(STATUS "Could not find pandoc, cannot recreate documentation files")
endif()

=== libdssp/CMakeLists.txt ===
# Use the version of the parent list file, if any. May need a fix someday.
if(NOT CMAKE_PARENT_LIST_FILE)
	set(PROJECT_VERSION 4.4.8)
endif()

project(libdssp VERSION ${PROJECT_VERSION})

include(CMakePackageConfigHelpers)

# We do not want to write an export file for all our symbols...
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS ON)

# Create a revision file, containing the current git version info
write_version_header("${CMAKE_CURRENT_SOURCE_DIR}/src" LIB_NAME libdssp)

# The DSSP code is in a separate library, optionally to be used by others
add_library(dssp)
add_library(dssp::dssp ALIAS dssp)

target_sources(dssp
	PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}/src/dssp.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/dssp-io.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/src/dssp-io.hpp
	PUBLIC
	FILE_SET dssp_header TYPE HEADERS
	BASE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include
	FILES include/dssp.hpp
)

target_link_libraries(dssp PUBLIC cifpp::cifpp)

set_target_properties(dssp PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(dssp PUBLIC cxx_std_17)

target_include_directories(dssp
	PUBLIC
	"$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include;${CMAKE_CURRENT_SOURCE_DIR}/../src>"
	"$<INSTALL_INTERFACE:include>"
)

# Install rules
install(TARGETS dssp
	EXPORT dssp
	FILE_SET dssp_header DESTINATION "include")

if(MSVC AND BUILD_SHARED_LIBS)
	install(
		FILES $<TARGET_PDB_FILE:dssp>
		DESTINATION "lib"
		OPTIONAL)
endif()

install(EXPORT dssp
	FILE "dsspTargets.cmake"
	NAMESPACE dssp::
	DESTINATION lib/cmake/dssp
)

set(CONFIG_TEMPLATE_FILE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/dsspConfig.cmake.in)

configure_package_config_file(
	${CONFIG_TEMPLATE_FILE}
	${CMAKE_CURRENT_BINARY_DIR}/dssp/dsspConfig.cmake
	INSTALL_DESTINATION lib/cmake/dssp
)

install(FILES
	"${CMAKE_CURRENT_BINARY_DIR}/dssp/dsspConfig.cmake"
	DESTINATION lib/cmake/dssp
	COMPONENT Devel
)

set(dssp_MAJOR_VERSION ${CMAKE_PROJECT_VERSION_MAJOR})
set_target_properties(dssp PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${dssp_MAJOR_VERSION}
	INTERFACE_dssp_MAJOR_VERSION ${dssp_MAJOR_VERSION})

set_property(TARGET dssp APPEND PROPERTY
	COMPATIBLE_INTERFACE_STRING dssp_MAJOR_VERSION
)

write_basic_package_version_file(
	"${CMAKE_CURRENT_BINARY_DIR}/dssp/dsspConfigVersion.cmake"
	VERSION ${PROJECT_VERSION}
	COMPATIBILITY AnyNewerVersion
)

# set(CIFPP_DATA_DIR "${CMAKE_INSTALL_FULL_DATADIR}/libcifpp")
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/mmcif_pdbx/dssp-extension.dic"
        DESTINATION share/libcifpp)

=== test/CMakeLists.txt ===
if(NOT(Catch2_FOUND OR TARGET Catch2))
	find_package(Catch2 QUIET)

	if(NOT Catch2_FOUND)
		include(FetchContent)

		FetchContent_Declare(
			Catch2
			GIT_REPOSITORY https://github.com/catchorg/Catch2.git
			GIT_TAG v2.13.9)

		FetchContent_MakeAvailable(Catch2)

		set(Catch2_VERSION "2.13.9")
	endif()
endif()

add_executable(unit-test-dssp ${CMAKE_CURRENT_SOURCE_DIR}/unit-test-dssp.cpp ${PROJECT_SOURCE_DIR}/libdssp/src/dssp-io.cpp)

if(USE_RSRC)
	mrc_target_resources(unit-test-dssp
		${CIFPP_SHARE_DIR}/mmcif_pdbx.dic ${CIFPP_SHARE_DIR}/mmcif_ddl.dic
		${CMAKE_CURRENT_SOURCE_DIR}/../libdssp/mmcif_pdbx/dssp-extension.dic)
endif()

target_include_directories(unit-test-dssp PRIVATE
	${CMAKE_CURRENT_SOURCE_DIR}/src
	${CMAKE_CURRENT_SOURCE_DIR}/include
)

target_link_libraries(unit-test-dssp PRIVATE dssp cifpp::cifpp Catch2::Catch2)

if(MSVC)
	# Specify unwind semantics so that MSVC knowns how to handle exceptions
	target_compile_options(unit-test-dssp PRIVATE /EHsc)
endif()

if("${Catch2_VERSION}" VERSION_GREATER_EQUAL 3.0.0)
	target_compile_definitions(unit-test-dssp PUBLIC CATCH22=0)
else()
	target_compile_definitions(unit-test-dssp PUBLIC CATCH22=1)
endif()

add_test(NAME unit-test-dssp COMMAND $<TARGET_FILE:unit-test-dssp>
	--data-dir ${CMAKE_CURRENT_SOURCE_DIR}
	--rsrc-dir ${CMAKE_CURRENT_BINARY_DIR}/_deps/cifpp-src/rsrc)

=== debian/changelog ===
dssp (4.4.10-1) unstable; urgency=medium

  * New upstream. 
  * Fix ftbfs, Closes: #1045047 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 17 Oct 2024 18:50:13 +0200

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, libcifpp-dev
Restrictions: allow-stderr
